package jp.gr.java_conf.abagames.river;

import jp.gr.java_conf.abagames.util.j3d.*;
import javax.media.j3d.*;

/**
  {[g_
  */
public class Boat {

  private Shape3D getShape3D() {
    float[] cordinates = {
     0,-2,-15, 1,-2,-14, 1,-2,-10, 1,0,-10, 1,0,-2, 3,0,0, 1,0,2,
     -1,0,2, -3,0,0, -1,0,-2, -1,0,-10, -1,-2,-10, -1,-2,-14};
    int[] cordinateIndices = {
     0,12,1, 1,12,11, 1,11,2, 2,11,10, 2,10,3, 3,10,7, 3,7,6, 4,6,5, 9,8,7};
    float[] colors = {
      1,1,1, 1,0.6f,0.4f};
    int[] colorIndices = {
     1,1,1, 1,1,1, 1,1,1, 0,0,0, 0,0,0, 0,0,0, 0,0,0, 0,0,0, 0,0,0};
    float[] normals = {
     0,1,0, 0,0,1};
    int[] normalIndices = {
     0,0,0, 0,0,0, 0,0,0, 1,1,1, 1,1,1, 0,0,0, 0,0,0, 0,0,0, 0,0,0};

    IndexedTriangleArray gmt = new IndexedTriangleArray(
     13,
     IndexedTriangleArray.COORDINATES
      | IndexedTriangleArray.COLOR_3
      | IndexedTriangleArray.NORMALS,
     27);
    gmt.setCoordinates(0, cordinates);
    gmt.setCoordinateIndices(0, cordinateIndices);
    gmt.setColors(0, colors);
    gmt.setColorIndices(0, colorIndices);
    gmt.setNormals(0, normals);
    gmt.setNormalIndices(0, normalIndices);

    Appearance app = new Appearance();
    Material mtr = new Material();
    mtr.setLightingEnable(true);
    app.setMaterial(mtr);
    PolygonAttributes pa = new PolygonAttributes();
    pa.setCullFace(PolygonAttributes.CULL_NONE);
    app.setPolygonAttributes(pa);

    return new Shape3D(gmt, app);
  }

  public TrnsObj to;
  private River river;
  private RiverRoller roller;

  public Boat(River rv, RiverRoller rr) {
    to = new TrnsObj(getShape3D());
    river = rv; roller = rr;
  }

  public float deg = 0;
  public float speed = 0;
  private int invCnt = 30;
  private float scrDeg = 0;
  private Transform3D rl = new Transform3D();

  /**
    _̍Eړ
    @param md ړ
    */
  public void move(float md) {
    deg += md;
    if ( deg < -0.5f || deg > 0.5f ) {
      deg -= md;
      return;
    }
    rl.rotY(md);
    to.trns.mul(rl, to.trns);
    to.setTransform();
  }

  public void wakeUp() {
    speed += (0.02f-speed)*0.02f;
    float cPst =-0.3f-Math.abs(deg)*0.1f, cDeg = -deg*14;
    if ( invCnt <= 0 ) {
      if ( roller.checkCollision(cPst, cDeg) ) {
        speed *= -0.3f;
        invCnt = 15;
      }
    } else {
      invCnt--;
    }
    scrDeg -= speed;
    if ( scrDeg <= 0 ) {
      river.addScore(1);
      scrDeg += 0.2f;
    }
    if ( roller.checkBonusCollision(cPst, cDeg) ) {
      river.addScore(20);
    }
  }
}
