package jp.gr.java_conf.abagames.river;

import jp.gr.java_conf.abagames.util.j3d.*;
import jp.gr.java_conf.abagames.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;

/**
  ڍ CNX
  */
public class River implements ITime {
  private ITimer timer;
  private RiverUI riverUI;
  private RiverRoller roller;
  private Boat boat;
  private Bonus bonus;
  private Score scrBd;

  public River() {
    riverUI = new RiverUI();
    Scene scene = new Scene(riverUI.getCanvas3D());
    scene.setViewpoint(T3DBuilder.setState(-5, 30, 25, -0.2f, -0.8f, 0, 1));
    scene.addLight(new AmbientLight(new Color3f(1f, 1f, 1f)));
    scene.addLight(
     new DirectionalLight(new Color3f(1f, 1f, 1f),
     new Vector3f(1, -1, 1)));
    scene.addLight(
     new DirectionalLight(new Color3f(0.2f, 0.2f, 0.2f),
     new Vector3f(-1, -1, -2)));

    roller = new RiverRoller();
    roller.to.trns = T3DBuilder.setState(0, 0, 0, 0, 0, 0, 1);
    roller.to.setTransformCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    BranchGroup rrBg = new BranchGroup();
    roller.to.setParent(rrBg);
    rrBg.compile();
    scene.root.addChild(rrBg);
    Box box = new Box();
    box.to.trns = T3DBuilder.setState(0, 0, 0, 0, 0, 0, 1);
    box.to.setTransform();
    box.to.setParent(scene.root);
    boat = new Boat(this, roller);
    boat.to.trns = T3DBuilder.setState(0, 0, 0, 0, 0, 0, 1);
    boat.to.setTransformCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    boat.to.setTransform();
    TransformGroup tg = new TransformGroup();
    tg.setTransform(T3DBuilder.setState(0, 18.2f, 18, 0, 0, 0, 1));
    boat.to.setParent(tg);
    scene.root.addChild(tg);
    scrBd = new Score();
    scrBd.to.trns = T3DBuilder.setState(-8, 18, 18.5f, 0, -(float)Math.PI/4, 0, 1);
    scrBd.to.setTransformCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    scrBd.setScore(0);
    scrBd.to.setTransform();
    scrBd.to.setParent(scene.root);

    scene.validate();
    riverUI.show();

    timer = new Timer(this);
    timer.activate(30);
  }

  private int leftTime = 1500;

  public void wakeUp() {
    roller.roll(boat.speed);
    leftTime--;
    if ( leftTime >= 0 ) {
      if ( riverUI.leftPressed ) {
        boat.move(0.015f);
      }
      if ( riverUI.rightPressed ) {
        boat.move(-0.015f);
      }
      boat.wakeUp();
      if ( leftTime == 0 ) {
        scrBd.to.trns = T3DBuilder.setState(-7, 17, 20, 0, -(float)Math.PI/8, 0, 2);
        scrBd.to.setTransform();
      }
    } else {
      boat.speed *= 0.9f;
      if ( leftTime < -100 ) {
        if ( riverUI.leftPressed || riverUI.rightPressed ) {
          score = 0;
          leftTime = 1500;
          scrBd.to.trns = T3DBuilder.setState(-8, 18, 18.5f, 0, -(float)Math.PI/4, 0, 1);
          scrBd.setScore(0);
          scrBd.to.setTransform();
        }
      }
    }
  }

  private int score = 0;

  public void addScore(int n) {
    score += n;
    scrBd.setScore(score);
  }

  public static void main(String[] args) {
    River river = new River();
    river.invokedStandalone = true;
  }
  private boolean invokedStandalone = false;
}

