package jp.gr.java_conf.abagames.river;

import jp.gr.java_conf.abagames.util.j3d.*;
import java.util.Random;
import javax.media.j3d.*;

/**
  ڍ샍[[
  */
public class RiverRoller {
  final static private int RCKNMB = 64;
  final static private float RADIUS = 16.0f;

  private Random rnd = new Random();
  private float[] rckPst = new float[RCKNMB];
  private float rckItv;
  private Bonus bonus;
  private float bnsDeg, bnsPst;
  public TrnsObj to;
  private Transform3D trns;

  public RiverRoller() {

    float[] flColors = {1,0.8f,0.6f};
    Roller rr = new Roller(RADIUS, flColors, 1.0f);
    float[] wtColors = {0.2f,0.2f,1};
    Roller wr = new Roller(RADIUS+0.5f, wtColors, 0.3f);
    rr.to.addChild(wr.to.trnsGroup);

    to = rr.to;
    float deg = 0;
    float pst;
    rckItv = (float)Math.PI*2/RCKNMB;
    for ( int i=0 ; i<RCKNMB ; i++, deg+=rckItv ) {
      Cube cb = new Cube();
      rckPst[RCKNMB-1-i] = pst = (rnd.nextFloat()-0.5f)*Roller.WIDTH*1.9f;
      trns = T3DBuilder.setState(
       pst,
       (float)Math.cos(deg)*RADIUS,
       (float)Math.sin(deg)*RADIUS,
       rnd.nextFloat()*(float)Math.PI*2,
       rnd.nextFloat()*(float)Math.PI*2,
       rnd.nextFloat()*(float)Math.PI*2,
       1);
      cb.to.trnsGroup.setTransform(trns);
      rr.to.addChild(cb.to.trnsGroup);
    }

    bonus = new Bonus();
    bonus.to.setTransformCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    bnsDeg = 0;
    setBonusPosition();
    rr.to.addChild(bonus.to.trnsGroup);
  }

  /**
    ̃{[iX̏ꏊݒ
    */
  private void setBonusPosition() {
    bnsPst = (rnd.nextFloat()-0.5f)*Roller.WIDTH*1.9f;
    bnsDeg += (float)Math.PI+(rnd.nextFloat()-0.5f)*0.2f;
    trns = T3DBuilder.setState(
     bnsPst,
     (float)Math.cos(-bnsDeg)*(RADIUS+1),
     (float)Math.sin(-bnsDeg)*(RADIUS+1),
     0,
     0,
     0,
     1);
    bonus.to.trnsGroup.setTransform(trns);
  }

  private Transform3D rl = new Transform3D();
  private float deg = 0;

  /**
    [[]
    @param md ]
    */
  public void roll(float md) {
    deg += md;
    rl.rotX(md);
    to.trns.mul(rl, to.trns);
    to.setTransform();
  }

  /**
    Ƃ̏Փ˂𔻒
    @param oDeg [[̃{[ĝpx
    @param x {[ĥxW
    */
  public boolean checkCollision(float oDeg, float x) {
    float d = oDeg + deg;
    float od = d % rckItv;
    int idx;
    if ( od < 0.03f ) {
      idx = (int)(d/rckItv);
    } else if ( od > rckItv-0.03f ) {
      idx = (int)(d/rckItv)+1;
    } else {
      return false;
    }
    idx %= RCKNMB; if ( idx < 0 ) return false;
    if ( Math.abs(x-rckPst[idx]) < 0.6f ) {
      return true;
    } else {
      return false;
    }
  }

  /**
    {[iXƂ̏Փ˂𔻒
    @param oDeg [[̃{[ĝpx
    @param x {[ĥxW
    */
  public boolean checkBonusCollision(float oDeg, float x) {
    float d = oDeg + deg;
    if ( Math.abs(d-bnsDeg) > 0.05f ) {
      if ( d-bnsDeg > 0.5f ) {
        setBonusPosition();
      }
      return false;
    }
    if ( Math.abs(x-bnsPst) < 1.5f ) {
      setBonusPosition();
      return true;
    } else {
      return false;
    }
  }
}
