package jp.gr.java_conf.abagames.river;

import jp.gr.java_conf.abagames.util.*;
import jp.gr.java_conf.abagames.util.j3d.*;
import javax.media.j3d.*;

/**
  [[
  */
public class Roller {
  final static public float WIDTH = 8.0f;
  final static private int FACENMB = 16;

  private Shape3D getShape3D(float rdu, float[] colors, float trnsPr) {
    float[] cordinates = new float[FACENMB*2*3];
    int[] cordinateIndices = new int[FACENMB*4];
    int[] colorIndices = new int[FACENMB*4];
    float[] normals = new float[FACENMB*3];
    int[] normalIndices = new int [FACENMB*4];

    int cIdx = 0, iIdx = 0, nIdx = 0;
    for ( int i=0 ; i<FACENMB ; i++, cIdx+=6, iIdx+=4, nIdx+=3 ) {
      cordinates[cIdx] = -WIDTH; cordinates[cIdx+3] = WIDTH;
      cordinates[cIdx+1] = cordinates[cIdx+4]
       = (float)Math.cos(Math.PI*2/FACENMB*i)*rdu;
      cordinates[cIdx+2] = cordinates[cIdx+5]
       = (float)Math.sin(Math.PI*2/FACENMB*i)*rdu;
      cordinateIndices[iIdx  ] = i*2;
      cordinateIndices[iIdx+1] = i*2+2;
      cordinateIndices[iIdx+2] = i*2+3;
      cordinateIndices[iIdx+3] = i*2+1;
      colorIndices[iIdx] = colorIndices[iIdx+1]
       = colorIndices[iIdx+2] = colorIndices[iIdx+3] = 0;
      normals[nIdx  ] = 0;
      normals[nIdx+1] = (float)Math.cos(Math.PI*2/FACENMB*i);
      normals[nIdx+2] = (float)Math.sin(Math.PI*2/FACENMB*i);
      normalIndices[iIdx] = normalIndices[iIdx+3] = i;
      normalIndices[iIdx+1] = normalIndices[iIdx+2] = i+1;
    }
    cordinateIndices[iIdx-3] = 0; cordinateIndices[iIdx-2] = 1;
    normalIndices[iIdx-3] = 0; normalIndices[iIdx-2] = 0;

    IndexedQuadArray gmt = new IndexedQuadArray(
     FACENMB*2,
     IndexedQuadArray.COORDINATES
      | IndexedQuadArray.COLOR_3
      | IndexedQuadArray.NORMALS,
     FACENMB*4);
    gmt.setCoordinates(0, cordinates);
    gmt.setCoordinateIndices(0, cordinateIndices);
    gmt.setColors(0, colors);
    gmt.setColorIndices(0, colorIndices);
    gmt.setNormals(0, normals);
    gmt.setNormalIndices(0, normalIndices);

    Appearance app = new Appearance();
    Material mtr = new Material();
    mtr.setLightingEnable(true);
    app.setMaterial(mtr);
    if ( trnsPr < 1 ) {
      TransparencyAttributes ta
       = new TransparencyAttributes(TransparencyAttributes.BLENDED, trnsPr);
      app.setTransparencyAttributes(ta);
    }
    return new Shape3D(gmt, app);
  }

  public TrnsObj to;

  public Roller(float radius, float[] colors, float trnsPr) {
    to = new TrnsObj(getShape3D(radius, colors, trnsPr));
  }
}
