package jp.gr.java_conf.abagames.util;

/**
  ^C}NX
*/
public class Timer implements Runnable, ITimer {
  private int duration = 0;

  private ITime myITime;
  private Thread myThread;

  private boolean loopf = true;

  public Timer(ITime aITime) {
    myITime = aITime;
  }

  public void run() {
    long nextMills = System.currentTimeMillis();
    long nw;
    while ( loopf ) {
      nw = System.currentTimeMillis();
      if ( nextMills > nw ) {
        try {
          Thread.currentThread().sleep(nextMills - nw);
        } catch ( InterruptedException e) {};
        nw = System.currentTimeMillis();
      }
      myITime.wakeUp();
      nextMills = (nw + nextMills)/2 + duration;
    }
  }

  public void activate(int aDuration) {
    duration = aDuration;
    myThread = new Thread(this);
    myThread.start();
  }

  public void terminate() {
    loopf = false;
  }
}
